#!/usr/bin/perl
# Natrnuje statistiky z treebanku a ulo je.



$starttime = time();



# Nast konfiguraci a knihovn funkce.
do "parslib.pl";



open(ANALYZA, ">".$konfig{prac}."/".$konfig{analyza});
print ANALYZA ("<csts lang=cs><h><source>PDT</source></h><doc file=\"$konfig{analyza}\" id=\"1\"><a><mod>s<txtype>pub<genre>mix<med>nws<temp>1994<authname>y<opus>ln94206<id>3</a><c><p n=\"1\">\n");




$slova[0] = "#";
$hesla[0] = "#";
$znacky[0] = "#";
$struktura[0] = -1;



print("Maska pro jmna soubor s trnovacmi daty: $konfig{train}\n");
@soubory = glob($konfig{train});
print("Nalezeno ".($#soubory+1)." soubor.\n");
for($isoubor = 0; $isoubor<=$#soubory; $isoubor++)
{
    open(SOUBOR, $soubory[$isoubor]);
    while(<SOUBOR>)
    {
        if(m/^<s/ && $ord>0)
        {
            zpracovat_vetu();
        }
        elsif(m/^<[fd][ >]/)
        {
            zpracovat_slovo();
        }
    }
    close(SOUBOR);
}
if($ord>0)
{
    # Nastavit pznak posledn vty, aby funkce zpracovat_vetu() provedla
    # naposledy i vechny akce, kter dl vdy jednou za as.
    $posledni_veta = 1;
    zpracovat_vetu();
}



close(ANALYZA);



print("Celkov poet slov: $n_slov\n");
print("Poet neprojektivn zavench slov: $n_neproj\n");
print("Celkov poet vt: $veta\n");
print("Poet vt obsahujcch neprojektivity: $n_neproj_vet\n");



$stoptime = time();
$cas = $stoptime-$starttime;
$hod = int($cas/3600);
$min = int(($cas%3600)/60);
$sek = $cas%60;
printf("Program bezel %02d:%02d:%02d hodin.\n", $hod, $min, $sek);



###############################################################################



#------------------------------------------------------------------------------
# Projde vtu a zapamatuje si vztahy v n.
#------------------------------------------------------------------------------
sub zpracovat_vetu
{
    print("Zpracovv se vta ".(++$veta)."\n");
    # Najt ve vt neprojektivity.
    # Projt uzly vty, pro kad projt uzly mezi nm a jeho dcm uzlem,
    # pro kad zjistit, zda le v podstromu zvislosti, je se nad nm klene.
    my $i, $r, $z, $i0, $i1, $j, $k;
    for($i = 1; $i<=$#slova; $i++)
    {
	$n_slov++;
        $z = $i;
        $r = $struktura[$i];
        next if($r==0);
        if($z<$r)
        {
            $i0 = $z;
            $i1 = $r;
        }
        else
        {
            $i0 = $r;
            $i1 = $z;
        }
        for($j = $i0+1; $j<$i1; $j++)
        {
            # Zjistit, zda j-t uzel m mezi svmi pedky r.
            $k = $j;
            while($struktura[$k]!=0)
            {
                if($struktura[$k]==$r)
                {
                    goto proj;
                }
                $k = $struktura[$k];
            }
            # Mezi pedky nebylo r nalezeno, j-t uzel je neprojektivn.
	    ##################################################################
	    # PODMINKA ZUZUJICI VYBER NEPROJEKTIVIT
	    ##################################################################
	    # Pokud je v dire pouze predlozka, nepovazovat za neprojektivitu.
	    #unless($i1-$i0==2 && $znacky[$j]=~m/^R/)
	    # Pokud je v dire sloveso (typicky modalni) a neprojektivni hranu
	    # ridi infinitiv slovesa, vybrat ji. Ignoruji se pripady, kdy
	    # infinitiv je sloveso "byt" (redukovana znacka "Vbyt"), a
	    # koordinace a apozice infinitivu.
	    #if($znacky[$r]=~m/^Vf/ && $znacky[$j]=~m/^V/)
	    # Pokud je neproj. hrana typu "vice nez"
	    #if($slova[$z] eq "ne")
	    # V dire lezi nejake typicke slovo.
	    if($slova[$j] eq "li")
	    {
		$diry[$j] = 1;
		$neproj[$z] = 1;
		$neproj = 1;
	    }
	    # Skoit sem, pokud prv kontrolovan j-t slovo netvo dru.
	    # To neznamen, e mezi dcm a zvislm uzlem se nenajde jet
	    # jin slovo, kter dru tvo. Nzev "proj" je tedy zavdjc.
	  proj:
        }
	if($neproj[$i])
	{
	    $n_neproj++;
	}
    }
    # Nalezla-li se alespo 1 neprojektivita, vypsat strom.
    if($neproj)
    {
	$n_neproj_vet++;
        $sid++;
        print ANALYZA ("<s id=\"$sid\" w=\"$pstrom\">\n");
        my $i;
        for($i = 1; $i<=$#slova; $i++)
        {
            my $znacka = "";
            if($neproj[$i])
            {
                $znacka = "Nprj";
            }
            if($diry[$i])
            {
                $znacka = "Dira";
            }
            print ANALYZA ("<f>$slova[$i]<l>$hesla[$i]<t>$znacky[$i]<A>$znacka<r>$i<g>$struktura[$i]\n");
        }
    }
    # Vymazat vtu, aby se mohla nast dal.
    splice(@slova, 1);
    splice(@hesla, 1);
    splice(@znacky, 1);
    splice(@struktura, 1);
    splice(@afun, 1);
    splice(@neproj);
    splice(@diry);
    $neproj = 0;
    $ord = 0;
    $sloveso = 0; # Zda vta obsahuje sloveso.
    $vynechat_vetu = 0;
}
